---
# Cop supports --autocorrect.
RSpec/DescribedClass:
  Exclude:
    - 'ee/spec/models/concerns/elastic/merge_request_spec.rb'
    - 'ee/spec/models/concerns/elastic/note_spec.rb'
    - 'ee/spec/models/concerns/elastic/project_spec.rb'
    - 'ee/spec/models/concerns/elastic/repository_spec.rb'
    - 'ee/spec/models/concerns/elastic/snippet_spec.rb'
    - 'ee/spec/models/dast_scanner_profile_spec.rb'
    - 'ee/spec/models/dast_site_profile_spec.rb'
    - 'ee/spec/models/ee/ci/job_artifact_spec.rb'
    - 'ee/spec/models/ee/ci/pending_build_spec.rb'
    - 'ee/spec/models/ee/ci/runner_spec.rb'
    - 'ee/spec/models/ee/gpg_key_spec.rb'
    - 'ee/spec/models/ee/group_spec.rb'
    - 'ee/spec/models/ee/iteration_spec.rb'
    - 'ee/spec/models/ee/merge_request_diff_spec.rb'
    - 'ee/spec/models/ee/project_spec.rb'
    - 'ee/spec/models/ee/vulnerability_spec.rb'
    - 'ee/spec/models/epic_issue_spec.rb'
    - 'ee/spec/models/epic_spec.rb'
    - 'ee/spec/models/geo/container_repository_registry_spec.rb'
    - 'ee/spec/models/geo/design_registry_spec.rb'
    - 'ee/spec/models/geo/package_file_registry_spec.rb'
    - 'ee/spec/models/geo/project_registry_spec.rb'
    - 'ee/spec/models/geo/secondary_usage_data_spec.rb'
    - 'ee/spec/models/incident_management/escalation_policy_spec.rb'
    - 'ee/spec/models/issuable_metric_image_spec.rb'
    - 'ee/spec/models/issue_spec.rb'
    - 'ee/spec/models/license_spec.rb'
    - 'ee/spec/models/merge_train_spec.rb'
    - 'ee/spec/models/plan_spec.rb'
    - 'ee/spec/models/project_import_state_spec.rb'
    - 'ee/spec/models/release_highlight_spec.rb'
    - 'ee/spec/models/requirements_management/requirement_spec.rb'
    - 'ee/spec/models/requirements_management/test_report_spec.rb'
    - 'ee/spec/models/resource_weight_event_spec.rb'
    - 'ee/spec/models/uploads/local_spec.rb'
    - 'ee/spec/models/vulnerabilities/finding_spec.rb'
    - 'ee/spec/models/vulnerabilities/flag_spec.rb'
    - 'ee/spec/models/vulnerabilities/read_spec.rb'
    - 'ee/spec/services/arkose/blocked_users_report_service_spec.rb'
    - 'ee/spec/services/ee/resource_events/synthetic_weight_notes_builder_service_spec.rb'
    - 'ee/spec/services/ee/users/reject_service_spec.rb'
    - 'ee/spec/services/resource_access_tokens/create_service_spec.rb'
    - 'ee/spec/services/security/ingestion/tasks/update_vulnerability_uuids_spec.rb'
    - 'ee/spec/services/users/captcha_challenge_service_spec.rb'
    - 'ee/spec/workers/concerns/elastic/indexing_control_spec.rb'
    - 'ee/spec/workers/elastic/migration_worker_spec.rb'
    - 'ee/spec/workers/geo/secondary/registry_consistency_worker_spec.rb'
    - 'ee/spec/workers/geo/verification_state_backfill_worker_spec.rb'
    - 'qa/spec/service/docker_run/base_spec.rb'
    - 'qa/spec/support/loglinking_spec.rb'
    - 'qa/spec/support/page_error_checker_spec.rb'
    - 'spec/config/settings_spec.rb'
    - 'spec/controllers/concerns/confirm_email_warning_spec.rb'
    - 'spec/controllers/concerns/controller_with_cross_project_access_check_spec.rb'
    - 'spec/controllers/concerns/enforces_admin_authentication_spec.rb'
    - 'spec/controllers/concerns/graceful_timeout_handling_spec.rb'
    - 'spec/controllers/concerns/group_tree_spec.rb'
    - 'spec/controllers/concerns/metrics_dashboard_spec.rb'
    - 'spec/controllers/concerns/product_analytics_tracking_spec.rb'
    - 'spec/controllers/concerns/redirects_for_missing_path_on_tree_spec.rb'
    - 'spec/controllers/concerns/redis_tracking_spec.rb'
    - 'spec/controllers/concerns/renders_commits_spec.rb'
    - 'spec/controllers/concerns/routable_actions_spec.rb'
    - 'spec/controllers/concerns/sourcegraph_decorator_spec.rb'
    - 'spec/controllers/concerns/spammable_actions/akismet_mark_as_spam_action_spec.rb'
    - 'spec/controllers/concerns/spammable_actions/captcha_check/html_format_actions_support_spec.rb'
    - 'spec/controllers/concerns/spammable_actions/captcha_check/json_format_actions_support_spec.rb'
    - 'spec/controllers/concerns/static_object_external_storage_spec.rb'
    - 'spec/controllers/repositories/git_http_controller_spec.rb'
    - 'spec/experiments/application_experiment_spec.rb'
    - 'spec/experiments/concerns/project_commit_count_spec.rb'
    - 'spec/frontend/fixtures/metrics_dashboard.rb'
    - 'spec/frontend/fixtures/timezones.rb'
    - 'spec/frontend/fixtures/u2f.rb'
    - 'spec/frontend/fixtures/webauthn.rb'
    - 'spec/graphql/gitlab_schema_spec.rb'
    - 'spec/graphql/graphql_triggers_spec.rb'
    - 'spec/graphql/types/global_id_type_spec.rb'
    - 'spec/initializers/google_api_client_spec.rb'
    - 'spec/lib/api/entities/project_spec.rb'
    - 'spec/lib/api/helpers_spec.rb'
    - 'spec/lib/bulk_imports/groups/stage_spec.rb'
    - 'spec/lib/bulk_imports/projects/stage_spec.rb'
    - 'spec/lib/expand_variables_spec.rb'
    - 'spec/lib/feature_spec.rb'
    - 'spec/lib/gitlab/application_context_spec.rb'
    - 'spec/lib/gitlab/asciidoc/html5_converter_spec.rb'
    - 'spec/lib/gitlab/buffered_io_spec.rb'
    - 'spec/lib/gitlab/checks/snippet_check_spec.rb'
    - 'spec/lib/gitlab/ci/tags/bulk_insert_spec.rb'
    - 'spec/lib/gitlab/ci/trace/chunked_io_spec.rb'
    - 'spec/lib/gitlab/ci/variables/collection/item_spec.rb'
    - 'spec/lib/gitlab/ci/variables/collection/sort_spec.rb'
    - 'spec/lib/gitlab/ci/variables/collection_spec.rb'
    - 'spec/lib/gitlab/ci/yaml_processor_spec.rb'
    - 'spec/lib/gitlab/config/entry/composable_array_spec.rb'
    - 'spec/lib/gitlab/config/entry/composable_hash_spec.rb'
    - 'spec/lib/gitlab/current_settings_spec.rb'
    - 'spec/lib/gitlab/database/background_migration/health_status_spec.rb'
    - 'spec/lib/gitlab/database/load_balancing/host_spec.rb'
    - 'spec/lib/gitlab/database/load_balancing/primary_host_spec.rb'
    - 'spec/lib/gitlab/database/migrations/lock_retry_mixin_spec.rb'
    - 'spec/lib/gitlab/database/query_analyzers/gitlab_schemas_validate_connection_spec.rb'
    - 'spec/lib/gitlab/database/reindexing_spec.rb'
    - 'spec/lib/gitlab/database/similarity_score_spec.rb'
    - 'spec/lib/gitlab/database_spec.rb'
    - 'spec/lib/gitlab/email/handler_spec.rb'
    - 'spec/lib/gitlab/email/hook/smime_signature_interceptor_spec.rb'
    - 'spec/lib/gitlab/encrypted_configuration_spec.rb'
    - 'spec/lib/gitlab/error_tracking/logger_spec.rb'
    - 'spec/lib/gitlab/git/blame_spec.rb'
    - 'spec/lib/gitlab/git/blob_spec.rb'
    - 'spec/lib/gitlab/git/commit_spec.rb'
    - 'spec/lib/gitlab/git/compare_spec.rb'
    - 'spec/lib/gitlab/git/diff_collection_spec.rb'
    - 'spec/lib/gitlab/git/repository_spec.rb'
    - 'spec/lib/gitlab/git/tree_spec.rb'
    - 'spec/lib/gitlab/git_access_snippet_spec.rb'
    - 'spec/lib/gitlab/gl_repository/repo_type_spec.rb'
    - 'spec/lib/gitlab/import_formatter_spec.rb'
    - 'spec/lib/gitlab/inactive_projects_deletion_warning_tracker_spec.rb'
    - 'spec/lib/gitlab/kubernetes/kube_client_spec.rb'
    - 'spec/lib/gitlab/no_cache_headers_spec.rb'
    - 'spec/lib/gitlab/pagination/keyset/order_spec.rb'
    - 'spec/lib/gitlab/relative_positioning/range_spec.rb'
    - 'spec/lib/gitlab/runtime_spec.rb'
    - 'spec/lib/gitlab/search_context/controller_concern_spec.rb'
    - 'spec/lib/gitlab/seeder_spec.rb'
    - 'spec/lib/gitlab/serverless/service_spec.rb'
    - 'spec/lib/gitlab/sidekiq_middleware/size_limiter/client_spec.rb'
    - 'spec/lib/gitlab/suggestions/commit_message_spec.rb'
    - 'spec/lib/gitlab/usage/metrics/aggregates/sources/redis_hll_spec.rb'
    - 'spec/lib/gitlab/utils/measuring_spec.rb'
    - 'spec/lib/gitlab/webpack/file_loader_spec.rb'
    - 'spec/lib/gitlab/webpack/manifest_spec.rb'
    - 'spec/lib/gitlab/x509/commit_spec.rb'
    - 'spec/lib/gitlab/x509/signature_spec.rb'
    - 'spec/lib/peek/views/active_record_spec.rb'
    - 'spec/lib/service_ping/devops_report_spec.rb'
    - 'spec/lib/sidebars/panel_spec.rb'
    - 'spec/mailers/emails/service_desk_spec.rb'
    - 'spec/metrics_server/metrics_server_spec.rb'
    - 'spec/models/active_session_spec.rb'
    - 'spec/models/alert_management/alert_spec.rb'
    - 'spec/models/application_record_spec.rb'
    - 'spec/models/application_setting_spec.rb'
    - 'spec/models/awareness_session_spec.rb'
    - 'spec/models/broadcast_message_spec.rb'
    - 'spec/models/chat_name_spec.rb'
    - 'spec/models/ci/build_runner_session_spec.rb'
    - 'spec/models/ci/build_spec.rb'
    - 'spec/models/ci/group_variable_spec.rb'
    - 'spec/models/ci/job_artifact_spec.rb'
    - 'spec/models/ci/namespace_mirror_spec.rb'
    - 'spec/models/ci/pipeline_artifact_spec.rb'
    - 'spec/models/ci/pipeline_spec.rb'
    - 'spec/models/ci/processable_spec.rb'
    - 'spec/models/ci/ref_spec.rb'
    - 'spec/models/ci/variable_spec.rb'
    - 'spec/models/ci_platform_metric_spec.rb'
    - 'spec/models/clusters/cluster_spec.rb'
    - 'spec/models/commit_spec.rb'
    - 'spec/models/commit_status_spec.rb'
    - 'spec/models/concerns/blocks_unsafe_serialization_spec.rb'
    - 'spec/models/concerns/bulk_insertable_associations_spec.rb'
    - 'spec/models/concerns/counter_attribute_spec.rb'
    - 'spec/models/concerns/has_user_type_spec.rb'
    - 'spec/models/concerns/integrations/enable_ssl_verification_spec.rb'
    - 'spec/models/concerns/integrations/reset_secret_fields_spec.rb'
    - 'spec/models/concerns/issuable_spec.rb'
    - 'spec/models/concerns/mentionable_spec.rb'
    - 'spec/models/concerns/resolvable_note_spec.rb'
    - 'spec/models/concerns/token_authenticatable_spec.rb'
    - 'spec/models/customer_relations/contact_spec.rb'
    - 'spec/models/customer_relations/organization_spec.rb'
    - 'spec/models/dependency_proxy/manifest_spec.rb'
    - 'spec/models/deployment_spec.rb'
    - 'spec/models/group_spec.rb'
    - 'spec/models/import_failure_spec.rb'
    - 'spec/models/integration_spec.rb'
    - 'spec/models/internal_id_spec.rb'
    - 'spec/models/issue_assignee_spec.rb'
    - 'spec/models/issue_spec.rb'
    - 'spec/models/jira_import_state_spec.rb'
    - 'spec/models/label_link_spec.rb'
    - 'spec/models/lfs_objects_project_spec.rb'
    - 'spec/models/loose_foreign_keys/deleted_record_spec.rb'
    - 'spec/models/member_spec.rb'
    - 'spec/models/merge_request_assignee_spec.rb'
    - 'spec/models/merge_request_diff_commit_spec.rb'
    - 'spec/models/merge_request_diff_file_spec.rb'
    - 'spec/models/merge_request_spec.rb'
    - 'spec/models/milestone_spec.rb'
    - 'spec/models/namespace_spec.rb'
    - 'spec/models/namespace_statistics_spec.rb'
    - 'spec/models/oauth_access_token_spec.rb'
    - 'spec/models/packages/dependency_spec.rb'
    - 'spec/models/packages/maven/metadatum_spec.rb'
    - 'spec/models/packages/package_spec.rb'
    - 'spec/models/pages_deployment_spec.rb'
    - 'spec/models/pages_domain_spec.rb'
    - 'spec/models/performance_monitoring/prometheus_dashboard_spec.rb'
    - 'spec/models/performance_monitoring/prometheus_metric_spec.rb'
    - 'spec/models/performance_monitoring/prometheus_panel_group_spec.rb'
    - 'spec/models/performance_monitoring/prometheus_panel_spec.rb'
    - 'spec/models/plan_spec.rb'
    - 'spec/models/postgresql/detached_partition_spec.rb'
    - 'spec/models/preloaders/user_max_access_level_in_projects_preloader_spec.rb'
    - 'spec/models/preloaders/users_max_access_level_in_projects_preloader_spec.rb'
    - 'spec/models/project_feature_usage_spec.rb'
    - 'spec/models/project_setting_spec.rb'
    - 'spec/models/project_spec.rb'
    - 'spec/models/projects/topic_spec.rb'
    - 'spec/models/release_highlight_spec.rb'
    - 'spec/models/release_spec.rb'
    - 'spec/models/route_spec.rb'
    - 'spec/models/todo_spec.rb'
    - 'spec/models/u2f_registration_spec.rb'
    - 'spec/models/user_custom_attribute_spec.rb'
    - 'spec/models/user_preference_spec.rb'
    - 'spec/models/user_spec.rb'
    - 'spec/models/users/merge_request_interaction_spec.rb'
    - 'spec/models/users_statistics_spec.rb'
    - 'spec/models/wiki_directory_spec.rb'
    - 'spec/models/work_items/type_spec.rb'
    - 'spec/serializers/context_commits_diff_entity_spec.rb'
    - 'spec/services/alert_management/alerts/todo/create_service_spec.rb'
    - 'spec/services/auth/dependency_proxy_authentication_service_spec.rb'
    - 'spec/services/ci/register_job_service_spec.rb'
    - 'spec/services/incident_management/issuable_escalation_statuses/after_update_service_spec.rb'
    - 'spec/services/issuable/process_assignees_spec.rb'
    - 'spec/services/loose_foreign_keys/cleaner_service_spec.rb'
    - 'spec/services/merge_requests/update_service_spec.rb'
    - 'spec/services/notification_service_spec.rb'
    - 'spec/services/projects/create_service_spec.rb'
    - 'spec/services/resource_access_tokens/create_service_spec.rb'
    - 'spec/services/resource_events/synthetic_label_notes_builder_service_spec.rb'
    - 'spec/services/snippets/update_service_spec.rb'
    - 'spec/services/system_hooks_service_spec.rb'
    - 'spec/services/user_project_access_changed_service_spec.rb'
    - 'spec/services/webauthn/authenticate_service_spec.rb'
    - 'spec/services/webauthn/register_service_spec.rb'
    - 'spec/support_specs/helpers/active_record/query_recorder_spec.rb'
    - 'spec/support_specs/helpers/graphql_helpers_spec.rb'
    - 'spec/support_specs/matchers/exceed_query_limit_helpers_spec.rb'
    - 'spec/validators/html_safety_validator_spec.rb'
    - 'spec/workers/bulk_imports/entity_worker_spec.rb'
    - 'spec/workers/jira_connect/retry_request_worker_spec.rb'
